[bits 16]
[org 0x1000]
STACK equ 0x7c00
KERNEL_OFFSET equ 0x1800
VBE_INFO equ 0x1000 ;Don't forget to change in kernel! <IMPORTANT>
BOOT_DRIVE equ 0x1200

mov bp, STACK
mov sp, bp

;mov ax, 0x4F02 ;VBD mode
;mov bx, 0x4118 ;1024x768x? TODO: Query BIOS to find out supported modes
;int 0x10 ; switch to VGA 640x480
;cmp ax, 0x004F   ; test for error
;jne error

;Get VBE mode
;mov esi, 0
;mov di, VBE_INFO
;mov ax, 0x4f01
;mov cx, 0x4118 ;Redundant for now
;int 0x10
;cmp ax, 0x004F   ; test for error
;jne error


mov bx, MSG_REAL_MODE
call print
call print_nl

call load_kernel

;call switch_to_pm ; disable interrupts, load GDT,  etc. Finally jumps to 'BEGIN_PM'
jmp $ ; Never executed

;Why does moving the incldues below load_kernel change the outcome??
%include "boot/print.asm"
%include "boot/print_hex.asm"
;%include "boot/gdt.asm"
%include "boot/32bit_print.asm"
;%include "boot/switch_pm.asm"
%include "boot/disk2.asm"

;Load the rest of the kernel - finish what the first stage started
load_kernel:
    call print_nl
    mov eax, 0xDEADBEEF
    jmp $
    mov bx, MSG_VIDEO_ERROR
    call print

    mov dh, [SEC_COUNT]
    call print_hex

    mov dh, [CYL_COUNT]
    call print_hex

    mov dh, [HEAD_COUNT]
    call print_hex


    call disk_load
    ;Increment CURRENT_MEM_LOAD
    mov cx, [CURRENT_MEM_LOAD]
    add cx, 0x200
    mov [CURRENT_MEM_LOAD], cx

    mov al, [SEC_COUNT]
    cmp al, 0x12 ; If al >= 0x12, we're done. The rest will be loaded by the second stage 18 = 0x12
    jge inc_head

    mov ch, [CYL_COUNT]
    cmp ch, 3
    jge done_load

    ;Increment sector ID
    inc al
    mov [SEC_COUNT], al
    jmp load_kernel

inc_head:
    mov dh, [HEAD_COUNT]
    cmp dh, 1
    jge inc_cyl
    inc dh
    mov [HEAD_COUNT], dh
    mov al, 1
    mov [SEC_COUNT], al
    jmp load_kernel

inc_cyl:
    mov ch, [CYL_COUNT]
    inc ch
    mov [CYL_COUNT], ch
    ;Reset head count
    mov dh, 0
    mov [HEAD_COUNT], dh
    ;Reset sector count
    mov al, 1
    mov [SEC_COUNT], al
    jmp load_kernel

done_load:
    ret

SEC_COUNT db 1
CYL_COUNT db 0
HEAD_COUNT db 1
CURRENT_MEM_LOAD dw 0x3400 ;Probably 0x3200

MSG_REAL_MODE db "Started in 16-bit Real Mode", 0
MSG_PROT_MODE db "Landed in 32-bit Protected Mode", 0
MSG_LOAD_KERNEL db "Loading kernel into memory", 0
MSG_RETURNED_KERNEL db "Returned from kernel. Error?", 0
MSG_VIDEO_ERROR db "VESA_ERR", 0


[bits 32]
BEGIN_PM:
    mov ebx, MSG_PROT_MODE
    call print_string_pm
    call KERNEL_OFFSET; Give control to the kernel
    jmp $ ; Stay here when the kernel returns control to us (if ever)

error:
    mov ebx, MSG_VIDEO_ERROR
    call print_string_pm
    jmp $
times 2048 - ($-$$) db 0 ; This second stage can be up to 2KB, for now
